diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
index c5a46949c..abaebad9a 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
@@ -18,7 +18,6 @@ import org.joml.Vector3f;
 import org.joml.Vector3fc;
 import org.slf4j.Logger;
 import org.useless.dragonfly.DisplayPos;
-import org.useless.dragonfly.data.block.BlockModelData;
 
 import java.util.Map;
 
@@ -69,6 +68,15 @@ public class CompiledBlockModelMojangData {
 
         this.displayPosMap = new Object2ObjectOpenHashMap<>();
         if (data.displayPositions != null) this.displayPosMap.putAll(data.displayPositions);
+        if (!this.displayPosMap.containsKey(DisplayPos.FIRST_PERSON_LEFT_HAND) && this.displayPosMap.containsKey(DisplayPos.FIRST_PERSON_RIGHT_HAND)) {
+            var right = this.displayPosMap.getOrDefault(DisplayPos.FIRST_PERSON_RIGHT_HAND, DisplayPos.DEFAULT_DISPLAY_POS);
+            var left = new DisplayPos(right.tx, right.ty, right.tz, right.rx, right.ry + 180, right.rz, right.sx, right.sy, right.sz);
+            this.displayPosMap.put(DisplayPos.FIRST_PERSON_LEFT_HAND, left);
+        }
+        if (!this.displayPosMap.containsKey(DisplayPos.THIRD_PERSON_LEFT_HAND) && this.displayPosMap.containsKey(DisplayPos.THIRD_PERSON_RIGHT_HAND)) {
+            var right = this.displayPosMap.getOrDefault(DisplayPos.THIRD_PERSON_RIGHT_HAND, DisplayPos.DEFAULT_DISPLAY_POS);
+            this.displayPosMap.put(DisplayPos.THIRD_PERSON_LEFT_HAND, right);
+        }
 
         this.particleIndices = new int[6];
         if (data.particleIndices != null) {
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
index 1770709c5..b8b725172 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
@@ -33,6 +33,7 @@ import java.util.ArrayList;
 import java.util.Collection;
 import java.util.HashMap;
 import java.util.HashSet;
+import java.util.LinkedHashMap;
 import java.util.List;
 import java.util.Map;
 
@@ -82,7 +83,7 @@ public class EntityGeometryMojangData implements EntityModelData {
         this.vBoundsOffset = vBoundsOffset;
         this.textureWidth = textureWidth;
         this.textureHeight = textureHeight;
-        this.bones = new HashMap<>();
+        this.bones = new LinkedHashMap<>();
 
         for (final Bone.Builder builder : bones) {
             @NotNull final Bone bone = builder.build();
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 6fd868976..1b9a6ece7 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -1,10 +1,7 @@
 package net.minecraft.core.achievement.stat;
 
 import java.io.File;
-import java.util.Collections;
-import java.util.HashMap;
 import java.util.Locale;
-import java.util.Map;
 import java.util.UUID;
 
 import com.b100.json.JsonParser;
@@ -23,6 +20,7 @@ import net.minecraft.core.player.Session;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.jetbrains.annotations.Unmodifiable;
 import org.slf4j.Logger;
 
@@ -103,7 +101,7 @@ public class StatsCounter {
 		return achievement.parent == null || isUnlocked(achievement.parent);
 	}
 
-	public int readStat(Stat stat) {
+	public int readStat(@Nullable Stat stat) {
 		return sessionStats.getOrDefault(stat, 0);
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 77fa14be5..c52700d53 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -383,7 +383,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
 
     @Override
     public void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
-        player.addStat(Objects.requireNonNull(this.block.getStat(StatList.STAT_MINED)), 1);
+        player.addStat(this.block.getStat(StatList.STAT_MINED), 1);
 
         final @Nullable ItemStack heldItemStack = player.inventory.getCurrentItem();
         final @Nullable Item heldItem;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 374ef8cd2..82fb7ea0d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -144,7 +144,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
         if (vec.x() == 0.0D && vec.z() == 0.0D) {
             return -1000D;
         } else {
-            return Math.atan2(vec.z(), vec.x()) - Math.PI / 2;
+            return Math.atan2(vec.z(), vec.x());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index 88bba9d1e..b52c96889 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -10,6 +10,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
@@ -25,6 +26,7 @@ import org.joml.primitives.AABBdc;
 public class BlockLogicSpikes extends BlockLogic
 {
     public static final int MASK_POWERED = 0b0000_0001;
+    public static final int MASK_DIRECTION = 0b0000_1110;
 
     public BlockLogicSpikes(Block<?> block, Material mat)
     {
@@ -41,8 +43,12 @@ public class BlockLogicSpikes extends BlockLogic
 
         int meta = world.getBlockData(tilePos);
         if(world.hasNeighborSignal(tilePos)) {
-            world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
+            meta |= MASK_POWERED;
         }
+
+        meta |= ((side.getOpposite().getId() << 1) & MASK_DIRECTION);
+
+        world.setBlockDataNotify(tilePos, meta);
     }
 
     @Override
@@ -64,19 +70,26 @@ public class BlockLogicSpikes extends BlockLogic
 		if(isPowered != wasPowered) {
 			if(isPowered) {
 				world.playBlockEvent(null, tilePos, LevelListener.EVENT_PISTON_RETRACT, 0);
-				world.setBlockDataNotify(tilePos, MASK_POWERED);
+				world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
 			}else {
 				world.playBlockEvent(null, tilePos, LevelListener.EVENT_PISTON_EXTEND, 0);
-				world.setBlockDataNotify(tilePos, 0);
+				world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
 			}
 		}
 	}
 
-
     @Override
-    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         double thickness = 3/16d;
-        return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1,tilePos.y() + thickness, tilePos.z() + 1);
+        Direction direction = getDirectionFromData(source.getBlockData(tilePos));
+        return switch (direction) {
+            case UP -> new AABBd(0, 1 - thickness, 0, 1, 1, 1);
+            case NORTH -> new AABBd(0, 0, 0, 1, 1, thickness);
+            case SOUTH -> new AABBd(0, 0, 1 - thickness, 1, 1, 1);
+            case WEST -> new AABBd(0, 0, 0, thickness, 1, 1);
+            case EAST -> new AABBd(1 - thickness, 0, 0, 1, 1, 1);
+            default -> new AABBd(0, 0, 0, 1,thickness, 1);
+        };
     }
 
     @Override
@@ -122,6 +135,10 @@ public class BlockLogicSpikes extends BlockLogic
         return false;
     }
 
+    public static @NotNull Direction getDirectionFromData(int data) {
+        return Direction.getDirectionById((data & MASK_DIRECTION) >> 1);
+    }
+
     @Override
     public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side == Side.BOTTOM ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index a3b0048bf..efeb20e1a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1384,12 +1384,11 @@ public final class Blocks {
         }
     }
 
-    public static @Nullable Block<?> getBlock(int id)
-    {
-        if (id < 0 || id >= Blocks.blocksList.length) {
-            return null;
-        }
-        return Blocks.blocksList[id];
+    public static @NotNull Block<?> getBlock(int id) {
+        if (id < 0 || id >= Blocks.blocksList.length) return Blocks.AIR;
+        Block<?> block = Blocks.blocksList[id];
+        if (block == null) return Blocks.AIR;
+        return block;
     }
 
     public static boolean hasTag(int id, Tag<Block<?>> tag)
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
index f4552b196..1903e6bf6 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
@@ -5,6 +5,7 @@ import com.mojang.nbt.tags.IntTag;
 import com.mojang.nbt.tags.Tag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
@@ -153,6 +154,20 @@ public class Registry<T>
         return items.size();
     }
 
+    /**
+     * @return Collection of all registered value
+     */
+    public @NotNull Collection<T> values() {
+        return items;
+    }
+
+    /**
+     * @return Set of all registered keys
+     */
+    public @NotNull Set<String> keySet() {
+        return this.keyItemMap.keySet();
+    }
+
     @Override
     public Iterator<T> iterator() {
         return items.iterator();
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 27f6908a4..0c5cb84ea 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -887,32 +887,32 @@ public abstract class Entity
         setPos(this.x, this.y, this.z);
     }
 
-    public float distanceTo(Entity entity) {
-        float f = (float) (this.x - entity.x);
-        float f1 = (float) (this.y - entity.y);
-        float f2 = (float) (this.z - entity.z);
-        return MathHelper.sqrt_float(f * f + f1 * f1 + f2 * f2);
+    public float distanceTo(@NotNull Entity entity) {
+        float dx = (float) (this.x - entity.x);
+        float dy = (float) (this.y - entity.y);
+        float dz = (float) (this.z - entity.z);
+        return MathHelper.sqrt_float(dx * dx + dy * dy + dz * dz);
     }
 
-    public double distanceToSqr(double d, double d1, double d2) {
-        double d3 = this.x - d;
-        double d4 = this.y - d1;
-        double d5 = this.z - d2;
-        return d3 * d3 + d4 * d4 + d5 * d5;
+    public double distanceToSqr(double x, double y, double z) {
+        double dx = this.x - x;
+        double dy = this.y - y;
+        double dz = this.z - z;
+        return dx * dx + dy * dy + dz * dz;
     }
 
-    public double distanceTo(double d, double d1, double d2) {
-        double d3 = this.x - d;
-        double d4 = this.y - d1;
-        double d5 = this.z - d2;
-        return MathHelper.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
+    public double distanceTo(double x, double y, double z) {
+        double dx = this.x - x;
+        double dy = this.y - y;
+        double dz = this.z - z;
+        return MathHelper.sqrt(dx * dx + dy * dy + dz * dz);
     }
 
-    public double distanceToSqr(Entity entity) {
-        double d = this.x - entity.x;
-        double d1 = this.y - entity.y;
-        double d2 = this.z - entity.z;
-        return d * d + d1 * d1 + d2 * d2;
+    public double distanceToSqr(@NotNull Entity entity) {
+        double dx = this.x - entity.x;
+        double dy = this.y - entity.y;
+        double dz = this.z - entity.z;
+        return dx * dx + dy * dy + dz * dz;
     }
 
     public void playerTouch(Player player) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 68e76d4b4..41e12751f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -1134,6 +1134,13 @@ public abstract class Mob extends Entity {
         return 4;
     }
 
+    /**
+     * @return Max amount of entity within the spawn radius of the player, -1 to disable check
+     */
+    public int getMaxPerPlayer() {
+        return -1;
+    }
+
     @Override
     public void handleEntityEvent(byte byte0, float attackedAtYaw) {
         if (byte0 == 2) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index 47b147bf1..e58ae8690 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -242,6 +242,11 @@ public class MobGhast extends MobFlying
         return 1;
     }
 
+    @Override
+    public int getMaxPerPlayer() {
+        return 3;
+    }
+
     @Override
     public float calcBrightness(float partialTick) {
         return 1;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 3971b38eb..cc857a6c3 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -1317,10 +1317,10 @@ public abstract class Player
         addStat(statbase, 1);
     }
 
-    public void addStat(Stat statbase, int i) {
+    public void addStat(@Nullable Stat stat, int i) {
     }
 
-    public int getStat(Stat statbase) {
+    public int getStat(@Nullable Stat stat) {
         return 0;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
index accb5a936..b60c5d684 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -44,6 +45,14 @@ public class ItemStatue extends Item {
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.statueBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         this.statueBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
+
+        if (this.statueBlockBottom.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
+            TileEntity tileEntity = world.getTileEntity(blockPos);
+            if (tileEntity != null) {
+                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
+            }
+        }
+
         selfStack.consumeItem(player);
         return true;
     }
@@ -66,6 +75,14 @@ public class ItemStatue extends Item {
         world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.statueBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
         this.statueBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
+
+        if (this.statueBlockBottom.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
+            TileEntity tileEntity = world.getTileEntity(blockPos);
+            if (tileEntity != null) {
+                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
+            }
+        }
+
         selfStack.consumeItem(null);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/CommandManager.java b/game/core/src/main/java/net/minecraft/core/net/command/CommandManager.java
index 9b6699b7d..cd531c8bf 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/CommandManager.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/CommandManager.java
@@ -16,22 +16,27 @@ public class CommandManager {
         this.isServer = isServer;
     }
 
-    private final CommandDispatcher<CommandSource> DISPATCHER = new CommandDispatcher<>();
+    private CommandDispatcher<CommandSource> DISPATCHER = new CommandDispatcher<>();
     private static final Collection<CommandRegistry> externalCommands = new ArrayList<>();
     private static final Collection<CommandRegistry> externalServerCommands = new ArrayList<>();
 
     public void init() {
         if (this.isServer) {
             for (CommandRegistry registry : externalServerCommands) {
-                registry.register(DISPATCHER);
+                registry.register(this.DISPATCHER);
             }
         }
 
         for (CommandRegistry registry : externalCommands) {
-            registry.register(DISPATCHER);
+            registry.register(this.DISPATCHER);
         }
     }
 
+    public void reload() {
+        this.DISPATCHER = new CommandDispatcher<>();
+        init();
+    }
+
     public int execute(String s, CommandSource commandSource) throws CommandSyntaxException {
         return this.DISPATCHER.execute(s, commandSource);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java
index 431217d1d..ec768120f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java
@@ -26,13 +26,37 @@ public class ArgumentTypeGameMode implements ArgumentType<Gamemode> {
 
     @Override
     public Gamemode parse(StringReader reader) throws CommandSyntaxException {
-        final String string = reader.readString();
+        StringBuilder builder = new StringBuilder();
+        while (reader.canRead()) {
+            char peak = reader.peek();
+            if (peak == '[' || peak == '{' || peak == ' ') {
+                break;
+            }
+            builder.append(reader.read());
+        }
+        final String string = builder.toString();
 
+        String gamemodeString = string;
+        if (!string.contains(":")) {
+            if (!string.contains("gamemode/")) {
+                gamemodeString = "gamemode/" + string;
+            }
+        } else {
+            int colonIndex = string.indexOf(":");
+            String namespace = string.substring(0, colonIndex);
+            String value = string.substring(colonIndex + 1);
+            if (!string.contains("gamemode/")) {
+                gamemodeString = namespace + ":" + "gamemode/" + value;
+            }
+        }
         for (Gamemode gamemode : Registries.GAMEMODES) {
-            if (CommandHelper.matchesKeyString(gamemode.getId(), string)) {
+            if (CommandHelper.matchesKeyString(gamemode.getId(), gamemodeString)) {
                 return gamemode;
             }
         }
+        try {
+            return Gamemodes.getGamemodeByLegacyId(Integer.parseInt(string));
+        } catch (NumberFormatException ignored) {}
         throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.game_mode.invalid_game_mode"));
     }
 
@@ -40,7 +64,13 @@ public class ArgumentTypeGameMode implements ArgumentType<Gamemode> {
     public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
         String remaining = builder.getRemainingLowerCase();
         for (Gamemode gamemode : Registries.GAMEMODES) {
-            Optional<String> optional = CommandHelper.getStringToSuggest(gamemode.getId(), remaining);
+            String id = gamemode.getId();
+            Optional<String> optional;
+            if (id.startsWith("minecraft:")) {
+                optional = CommandHelper.getStringToSuggest(gamemode.getId().replace("minecraft:gamemode/", ""), remaining);
+            } else {
+                optional = CommandHelper.getStringToSuggest(gamemode.getId().replace("gamemode/", ""), remaining);
+            }
             optional.ifPresent(builder::suggest);
         }
         return builder.buildFuture();
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 3b0e2289d..f6634fd5a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -148,7 +148,9 @@ public final class SpawnerMobs {
                         final double dx = iPos.x + 0.5D;
                         final double dy = iPos.y;
                         final double dz = iPos.z + 0.5D;
-                        if (world.getClosestPlayer(dx, dy, dz, 24.0D) != null) continue;
+                        Player closest;
+                        if ((closest = world.getClosestPlayer(dx, dy, dz, 8 * 16)) == null) continue;
+                        if (closest.distanceToSqr(dx, dy, dz) < (24 * 24)) continue;
 
                         // Forbid mob spawning in a 24 block radius around spawn
                         if (checkSpawnDist) {
@@ -177,6 +179,12 @@ public final class SpawnerMobs {
                         if (countSpawned >= mobToSpawn.getMaxSpawnedInChunk()) {
                             continue chunkLoop;
                         }
+                        if (mobToSpawn.getMaxPerPlayer() >= 0) {
+                            var entities = world.getEntitiesWithinRadius(spawnListEntry.entityClass, closest.x, closest.y, closest.z, 8 * 16);
+                            if (entities.size() >= mobToSpawn.getMaxPerPlayer()) {
+                                continue chunkLoop;
+                            }
+                        }
                         ++countSpawned;
                         mobToSpawn.spawnInit();
                         world.entityJoinedWorld(mobToSpawn);
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 347b75b44..2bc8f61dd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1,42 +1,37 @@
 package net.minecraft.core.world;
 
-import static net.minecraft.core.Global.*;
-
-import java.util.*;
-
 import com.mojang.logging.LogUtils;
-
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Materials;
-import net.minecraft.core.block.support.ISupport;
-import net.minecraft.core.current.wire.WireHandler;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.animal.MobFireflyCluster;
-import net.minecraft.core.enums.Difficulty;
-import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.net.command.CommandManager;
-import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.MobFireflyCluster;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.debug.Debug;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
@@ -76,6 +71,20 @@ import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 import org.slf4j.Logger;
 
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Objects;
+import java.util.Random;
+import java.util.Set;
+import java.util.TreeSet;
+import java.util.UUID;
+
+import static net.minecraft.core.Global.DAY_LENGTH_TICKS;
+import static net.minecraft.core.Global.accessor;
+import static net.minecraft.core.Global.isServer;
+
 public class World implements MutableWorldSource {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static boolean AUTOSAVE = true;
@@ -142,7 +151,7 @@ public class World implements MutableWorldSource {
     private final @NotNull WireHandler wireHandler;
 
     //Usually called when a world is loaded or generated (Singleplayer & Server)
-    public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType) {
+    public World(@NotNull LevelStorage saveHandler, @NotNull String name, long seed, @Nullable Dimension dimension, @Nullable WorldType worldType, @Nullable Biome startingBiome) {
         this.saveHandler = saveHandler;
         this.savedDataStorage = new SavedDataStorage(saveHandler);
         this.levelData = saveHandler.getLevelData();
@@ -203,7 +212,7 @@ public class World implements MutableWorldSource {
 
         if (isNewWorld) {
             this.worldType.onWorldCreation(this);
-            getInitialSpawnLocation();
+            getInitialSpawnLocation(startingBiome);
         }
         updateSkyBrightness();
 
@@ -311,9 +320,9 @@ public class World implements MutableWorldSource {
         return accessor.createChunkProvider(this, chunkLoader);
     }
 
-    protected void getInitialSpawnLocation() {
+    protected void getInitialSpawnLocation(@Nullable Biome startingBiome) {
         this.findingSpawnPoint = true;
-        getWorldType().getInitialSpawnLocation(this);
+        getWorldType().getInitialSpawnLocation(this, startingBiome);
         this.findingSpawnPoint = false;
     }
 
@@ -1251,7 +1260,6 @@ public class World implements MutableWorldSource {
     public @NotNull List<@NotNull AABBdc> getCubes(@NotNull Entity entity, @NotNull AABBdc aabb) {
         TilePos d = new TilePos(entity);
         this.collidingBoundingBoxes.clear();
-        if (!d.inBounds(this)) return this.collidingBoundingBoxes;
 
         int minX = MathHelper.floor(aabb.minX());
         int maxX = MathHelper.floor(aabb.maxX() + 1.0D);
@@ -1277,11 +1285,9 @@ public class World implements MutableWorldSource {
             for (d.z = minZ - 1; d.z <= maxZ; d.z++) {
                 for (d.y = minY - 1; d.y <= maxY; d.y++) {
                     Block<?> block = getBlockType(d);
-                    if (block != null) {
-                        int metadata = getBlockData(d);
-                        if (block.collidesWithEntity(entity, this, d) && entity.collidesWithBlock(block, metadata)) {
-                            block.getCollisionAABBs(this, d, aabb, this.collidingBoundingBoxes);
-                        }
+                    int metadata = getBlockData(d);
+                    if (block.collidesWithEntity(entity, this, d) && entity.collidesWithBlock(block, metadata)) {
+                        block.getCollisionAABBs(this, d, aabb, this.collidingBoundingBoxes);
                     }
                 }
             }
@@ -2229,6 +2235,23 @@ public class World implements MutableWorldSource {
         return entities;
     }
 
+    public <T extends Entity> @NotNull List<@NotNull T> getEntitiesWithinRadius(@NotNull Class<T> ofClass, double x, double y, double z, double radius) {
+        int minX = MathHelper.floor(x - radius);
+        int minZ = MathHelper.floor(z - radius);
+        int maxX = MathHelper.ceil(x + radius);
+        int maxZ = MathHelper.ceil(z + radius);
+        List<@NotNull T> entities = new ArrayList<>();
+        for (int bx = minX; bx <= maxX; bx++) {
+            for (int bz = minZ; bz <= maxZ; bz++) {
+                if (isChunkLoaded(bx, bz)) {
+                    getChunkFromChunkCoords(bx, bz).getEntitiesWithinRadius(ofClass, x, y, z, radius, entities);
+                }
+            }
+        }
+
+        return entities;
+    }
+
     public @NotNull List<@NotNull Entity> getLoadedEntityList() {
         return this.entities;
     }
